/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include "src/sha3nist.c"
#include "src/cubehash.c"

static int
hex_encode (char *dest, const unsigned char *src, int len) {
    static const char hex[] = "0123456789abcdef";
    char *p = dest;
    const unsigned char *s = src;
    for (; len--; s++) {
        *p++ = hex[s[0] >> 4];
        *p++ = hex[s[0] & 0x0f];
    }
    return (int)(p - dest);
}

static int
base64_encode (char *dest, const unsigned char *src, int len) {
    static const char b64[] =
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    char *p = dest;
    const unsigned char *s = src;
    const unsigned char *end = src + len - 2;

    for (; s < end; s += 3) {
        *p++ = b64[s[0] >> 2];
        *p++ = b64[((s[0] & 3) << 4) + (s[1] >> 4)];
        *p++ = b64[((s[1] & 0xf) << 2) + (s[2] >> 6)];
        *p++ = b64[s[2] & 0x3f];
    }
    switch (len % 3) {
    case 1:
        *p++ = b64[s[0] >> 2];
        *p++ = b64[(s[0] & 3) << 4];
        break;
    case 2:
        *p++ = b64[s[0] >> 2];
        *p++ = b64[((s[0] & 3) << 4) + (s[1] >> 4)];
        *p++ = b64[((s[1] & 0xf) << 2)];
        break;
    }
    return (int)(p - dest);
}

static SV *
make_mortal_sv(pTHX_ const unsigned char *src, int bitlen, int enc) {
    char result[128];
    char *ret;
    int len = bitlen >> 3;

    switch (enc) {
    case 0:
        ret = (char *)src;
        break;
    case 1:
        len = hex_encode(result, src, len);
        ret = result;
        break;
    case 2:
        len = base64_encode(result, src, len);
        ret = result;
        break;
    }
    return sv_2mortal(newSVpv(ret, len));
}

typedef hashState *Digest__CubeHash__XS;

#line 85 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 229 "XS.c"

XS_EUPXS(XS_Digest__CubeHash__XS_cubehash_224); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_cubehash_224)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 95 "XS.xs"
    hashState ctx;
    int bitlen, i;
    unsigned char *data;
    STRLEN len;
    unsigned char result[64];
#line 245 "XS.c"
#line 101 "XS.xs"
    static const int ix2bits[] =
        {224, 224, 224, 256, 256, 256, 384, 384, 384, 512, 512, 512};
    bitlen = ix2bits[ix];
    if (Init(&ctx, bitlen) != SUCCESS)
        XSRETURN_UNDEF;
    for (i = 0; i < items; i++) {
        data = (unsigned char *)(SvPV(ST(i), len));
        if (Update(&ctx, data, len << 3) != SUCCESS)
            XSRETURN_UNDEF;
    }
    if (Final(&ctx, result) != SUCCESS)
        XSRETURN_UNDEF;
    ST(0) = make_mortal_sv(aTHX_ result, bitlen, ix % 3);
    XSRETURN(1);
#line 261 "XS.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__CubeHash__XS_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, hashsize");
    {
	SV *	class = ST(0)
;
	int	hashsize = (int)SvIV(ST(1))
;
	Digest__CubeHash__XS	RETVAL;
#line 121 "XS.xs"
    Newx(RETVAL, 1, hashState);
    if (Init(RETVAL, hashsize) != SUCCESS)
        XSRETURN_UNDEF;
#line 283 "XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Digest::CubeHash::XS", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__CubeHash__XS_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Digest__CubeHash__XS	self;
	Digest__CubeHash__XS	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::CubeHash::XS::clone",
			"self", "Digest::CubeHash::XS")
;
#line 131 "XS.xs"
    Newx(RETVAL, 1, hashState);
    Copy(self, RETVAL, 1, hashState);
#line 317 "XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Digest::CubeHash::XS", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__CubeHash__XS_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__CubeHash__XS	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::CubeHash::XS::reset",
			"self", "Digest::CubeHash::XS")
;
#line 140 "XS.xs"
    if (Init(self, self->hashbitlen) != SUCCESS)
        XSRETURN_UNDEF;
    XSRETURN(1);
#line 353 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__CubeHash__XS_hashsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_hashsize)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Digest__CubeHash__XS	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Digest::CubeHash::XS")
;
#line 150 "XS.xs"
    RETVAL = self->hashbitlen;
#line 383 "XS.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__CubeHash__XS_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__CubeHash__XS	self;
#line 158 "XS.xs"
    int i;
    unsigned char *data;
    STRLEN len;
#line 404 "XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::CubeHash::XS::add",
			"self", "Digest::CubeHash::XS")
;
#line 162 "XS.xs"
    for (i = 1; i < items; i++) {
        data = (unsigned char *)(SvPV(ST(i), len));
        if (Update(self, data, len << 3) != SUCCESS)
            XSRETURN_UNDEF;
    }
    XSRETURN(1);
#line 422 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__CubeHash__XS__add_bits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS__add_bits)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, msg, bitlen");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__CubeHash__XS	self;
	SV *	msg = ST(1)
;
	int	bitlen = (int)SvIV(ST(2))
;
#line 175 "XS.xs"
    int i;
    unsigned char *data;
    STRLEN len;
#line 447 "XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::CubeHash::XS::_add_bits",
			"self", "Digest::CubeHash::XS")
;
#line 179 "XS.xs"
    if (! bitlen)
        XSRETURN(1);
    data = (unsigned char *)(SvPV(msg, len));
    if (bitlen > len << 3)
        bitlen = len << 3;
    if (Update(self, data, bitlen) != SUCCESS)
        XSRETURN_UNDEF;
    XSRETURN(1);
#line 467 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__CubeHash__XS_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_digest)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Digest__CubeHash__XS	self;
#line 196 "XS.xs"
    unsigned char result[64];
#line 485 "XS.c"
	void *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::CubeHash::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Digest::CubeHash::XS")
;
#line 198 "XS.xs"
    if (Final(self, result) != SUCCESS)
        XSRETURN_UNDEF;
    Init(self, self->hashbitlen);
    ST(0) = make_mortal_sv(aTHX_ result, self->hashbitlen, ix);
    XSRETURN(1);
#line 504 "XS.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__CubeHash__XS_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__CubeHash__XS_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Digest__CubeHash__XS	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__CubeHash__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Digest::CubeHash::XS::DESTROY",
			"self")
;
#line 208 "XS.xs"
    Safefree(self);
#line 530 "XS.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Digest__CubeHash__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Digest__CubeHash__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_224", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_224_base64", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_224_hex", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_256", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 3;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_256_base64", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 5;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_256_hex", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 4;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_384", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 6;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_384_base64", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 8;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_384_hex", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 7;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_512", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 9;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_512_base64", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 11;
        cv = newXSproto_portable("Digest::CubeHash::XS::cubehash_512_hex", XS_Digest__CubeHash__XS_cubehash_224, file, ";@");
        XSANY.any_i32 = 10;
        (void)newXSproto_portable("Digest::CubeHash::XS::new", XS_Digest__CubeHash__XS_new, file, "$$");
        (void)newXSproto_portable("Digest::CubeHash::XS::clone", XS_Digest__CubeHash__XS_clone, file, "$");
        (void)newXSproto_portable("Digest::CubeHash::XS::reset", XS_Digest__CubeHash__XS_reset, file, "$");
        cv = newXSproto_portable("Digest::CubeHash::XS::algorithm", XS_Digest__CubeHash__XS_hashsize, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Digest::CubeHash::XS::hashsize", XS_Digest__CubeHash__XS_hashsize, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Digest::CubeHash::XS::add", XS_Digest__CubeHash__XS_add, file, "$;@");
        (void)newXSproto_portable("Digest::CubeHash::XS::_add_bits", XS_Digest__CubeHash__XS__add_bits, file, "$$$");
        cv = newXSproto_portable("Digest::CubeHash::XS::b64digest", XS_Digest__CubeHash__XS_digest, file, "$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Digest::CubeHash::XS::digest", XS_Digest__CubeHash__XS_digest, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Digest::CubeHash::XS::hexdigest", XS_Digest__CubeHash__XS_digest, file, "$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Digest::CubeHash::XS::DESTROY", XS_Digest__CubeHash__XS_DESTROY, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

